; v 1.0
; Adventure of Link

; $0120: track
; $0121: noloop wait flag
; $0122: music bank
; $0123: native track
; $0124: new track introduced
; $0125: scroll value
; $0126 current theme
hirom



org $Cf0000 ; main msu replacement

cmp #$80
BNE $0a
STZ $0126
STZ $2007
STA $07fb
RTL
PHA
SEC
SBC #$09
BCS special
	LDA $0707
	ASL A
	ASL A
	ASL A
	ASL A
	STA $0122
	PLA
	PHA
	CLC
	ADC $0122
	STA $0120
	JSR msu
	LDA #$03
	STA $2007
	STA $0124
	BRA end
special:
PLA
PHA
cmp #$10
BNE check20
	STZ $07dd
	STZ $07fc
	LDA #$04
	STA $2007
	LDA #$10
	JSR msu
	LDA #$01
	STA $0121
	STA $2007
	BRA end
check20:
cmp #$20
BNE check40
	LDA #$70; triforce
	JSR msu
	LDA #$01
	STA $0121
	STA $2007
	BRA end
check40:
	LDA $0707
	cmp #$05
	BEQ darkLink
	LDA #$04
	STA $2007
	LDA #$40
	JSR msu
	LDA #$01
	STA $0121
	STA $2007
	BRA end

	darkLink:
	LDA #$71
	STA $0120
	JSR msu
	LDA #$03
	STA $2007
	STA $0124 
	BRA end
	
end:
PLA
STA $0123
LDA #$80
STA $07fb
LDY #$00
RTL



msu:
PHA
cmp $0126
BNE $02
PLA
RTS
PLA
STZ $2006
STA $2004
STA $0126
STZ $2005
loop1:
BIT $2000
BVS loop1
LDA #$FF
STA $2006
RTS

org $Cf0100 ; pause start
LDA #$01
STA $EA
PHA
LDA $c8
cmp #$03
BNE $03
STZ $2007
PLA
RTL

org $Cf0150 ; pause end
PHA
LDA $c8
cmp #$03
BNE $05
LDA #$03
STA $2007
PLA
STA $074c
STA $0525
RTL


; wait for music being over
org $Cf0200
LDA $0121
cmp #$01
BEQ $03
LDA #$00
RTL
LDA $2000
AND #$10
BEQ waitover
LDA $07fc
BNE noHC
LDA #$FF
STA $07e5
STA $07e6
STA $07e7
LDA $0123
STa $07fb
RTL
noHC:
LDA #$80
STA $eb
LDA $0123
cmp #$40
BEQ $03
STZ $07fb
RTL
waitover:
LDA $0126 ; received triforce
cmp #$70
beq triforce
LDA $0120
jsr msu
LDA #$03
STA $2007
triforce:
LDA #$00
STA $07fb
STZ $0121
LDA $074c
BEQ $03
STZ $0123
RTL

org $Cf0300
lda $0124
cmp #$03
BEQ noMSUstop
LDA $0121
cmp #$01
BEQ noMSUstop
STZ $0126
STZ $2007
noMSUstop:
STZ $0124
LDA $120
cmp #$72
BEQ stopIntro
cmp #$73
BEQ stopIntro
cmp #$74
BEQ stopIntro
LDA #$00
RTL
stopIntro:
LDA #$80
STA $0120
LDA #$00
RTL

org $Cf0400 ; intro part 1 (prelude
LDA $120
cmp #$74
bne continuePart1
LDA $FC
cmp #$00
BNE continuePart1
LDA $0125
cmp #$01
BEQ playTrack2
LDA #$01
STA $0125
STA $FC
BRA continuePart1
playTrack2:
STZ $0121
LDA #$73
STA $120
jsr msu
STZ $0125
LDA #$01
STA $2007
continuePart1:
LDA $EA
cmp #$01
BEQ $03
AND #$01
RTL
STZ $0121
LDA #$72; play intro part 1
STA $120
JSR msu
STZ $0125
LDA #$01
STA $2007
LDA #$80
RTL

org $CF0500 ; intro part 2
LDA $120
cmp #$73 ; intro 2 already playing?
BNE $05
LDA #$02
cmp #$02
RTL
cmp #$72 ; if intro 1 then wait
beq wait
cmp #$74 ; if intro 3
beq wait
LDA #$00
cmp #$02
RTL
wait:
LDA $2000
AND #$10
BEQ $05
LDA #$00
cmp #$02
RTL
STZ $0121
LDA #$73 ;play intro track 2
STA $120
cmp #$80 
BNE $01
RTL
JSR msu
LDA #$01
STA $2007
LDA #$02
cmp #$02
RTL



org $CF0600 ; intro part 3
LDA $120
cmp #$74
BNE $05
LDA #$08
cmp #$08
RTL
cmp #$73
beq wait2
LDA #$00
cmp #$08
RTL
wait2:
LDA $2000
AND #$10
BEQ $05
LDA #$00
cmp #$08
RTL
STZ $0121
LDA #$74
STA $120
JSR msu
LDA #$01
STA $2007
LDA #$04
STA $0736
STA $0737
LDA #$08
cmp #$08
RTL

org $CF0700 ; boss explosion fix
STZ $0126
STZ $2007
lda #$80
STA $0120
STZ $07fb
RTL

org $cf0800
LDA #$75
jsr msu
LDA #$01
STA $2007
RTL

org $cf0850
STA $0756
STA $0755
STZ $2007
RTL
